using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.Diagnostics;
using System.Threading;

public class OpenAccessTracer : TraceListener
{
    int id;
    int count;
    RadTextBox textBox;
    Label label;
    Thread myThread;

    public OpenAccessTracer(RadTextBox textBox)
        : base("OpenAccess")
    {

        myThread = Thread.CurrentThread;

        Telerik.OpenAccess.Diagnostics.TraceAdapter.Instance.Level = "4";
        id = Telerik.OpenAccess.Diagnostics.TraceAdapter.Instance.Listeners.Add(this);
        this.textBox = textBox;

        count = 0;
    }

    public OpenAccessTracer(RadTextBox textBox, Label label)
        : base("OpenAccess")
    {

        myThread = Thread.CurrentThread;

        Telerik.OpenAccess.Diagnostics.TraceAdapter.Instance.Level = "4";
        id = Telerik.OpenAccess.Diagnostics.TraceAdapter.Instance.Listeners.Add(this);
        this.textBox = textBox;
        this.label = label;
        count = 0;
    }

    protected override void Dispose(bool disposing)
    {
        this.textBox.Text += count.ToString() + " queries executed.";
        Telerik.OpenAccess.Diagnostics.TraceAdapter.Instance.Listeners.RemoveAt(id);
        base.Dispose(disposing);
    }

    public void Reset()
    {
        textBox.Text = "";
        count = 0;
    }

    public override void Write(string message)
    {

    }

    public override void WriteLine(string message)
    {
        if (!myThread.Equals(Thread.CurrentThread))
            return;

        if (label != null)
        {
            label.Text = count.ToString() + " queries executed.";
        }

        if (message.StartsWith("driver.stat.execQuery"))
        {
            count++;
            textBox.Text += string.Format("{0}: {1}\r\n", count.ToString(), message.ToString().Substring(33));
        }
    }
}