﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.OpenAccess;
using PersistentClasses;

public partial class FetchPlans : System.Web.UI.UserControl
{
    OpenAccessTracer tracer = null;

    protected void RadGrid1_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        if (Session["tracer"] == null)
        {
            tracer = new OpenAccessTracer(RadTextBox1, Label1);
            Session["tracer"] = tracer;
        }
        else
        {
            ((OpenAccessTracer)Session["tracer"]).Reset();
        }

        IObjectScope scope = ObjectScopeProvider1.ObjectScope();
        // clears the scope 1st level cache
        scope.Transaction.Begin();
        scope.Transaction.Commit();

        if (CheckBox1.Checked)
        {
            scope.FetchPlan.Clear();
            scope.FetchPlan.Add(FetchPlan.Default);
            scope.FetchPlan.Add("Invoice Fetch Group");
            scope.FetchPlan.MaxDepth = 3;
            Label2.Text = "Try paging and sorting with the “Use fetch plan” option disabled. Note the number of executed queries.";

        }
        else
        {
            scope.FetchPlan.Clear();
            scope.FetchPlan.Add(FetchPlan.Default);
            Label2.Text = "Enable the “Use fetch plan” option and try paging and sorting. The number of executed queries will be decreased.";

        }

        IQuery query = scope.GetOqlQuery("select * from OrderExtent as o");
        query.ParallelFetch = CheckBox1.Checked;
        IQueryResult result = query.Execute();

        int count = result.Count;

        RadGrid1.DataSource = result;
    }

    protected void CheckBox1_CheckedChanged(object sender, EventArgs e)
    {


        RadTextBox1.Text = "";
        RadGrid1.Rebind();


    }

    public override void Dispose()
    {
        if (Session["tracer"] != null)
        {
            ((OpenAccessTracer)Session["tracer"]).Dispose();
            Session["tracer"] = null;
        }

        base.Dispose();
    }
    protected void RadGrid1_PageIndexChanged(object source, Telerik.Web.UI.GridPageChangedEventArgs e)
    {
        RadTextBox1.Text = "";
    }
}
